#!/usr/sbin/dtrace -C -Z -s
/*
 To run this script, please type the following command while in the same 
 directory (or specify the full pather rather than ./):

   sudo ./StartupScript -o dtrace_output.txt -c "<full path to executable> <arguments>"
 
 After the output file has been generated (here, it's dtrace_output.txt but you 
 may call it whatever you like), call up the trace document where
 this script was exported from and choose the "DTrace Data Import..." option
 from the "File" pulldown menu to import that data. 

*/

#pragma D option switchrate=1msec
#pragma D option bufsize=30m
#pragma D option stackindent=0
#pragma D option quiet

syscall::getpriority:entry/execname=="Instruments"/ {}

BEGIN{printf("<dtrace_output_begin/>\n %-14d\n0DDB18AF-2002-4D58-AF81-58EAA9924B9D\n", walltimestamp/1000);

isInApplicationStart = 0;
starttime = timestamp;}



objc$target:::entry/((( /*XRAYPREDICATELHS*/(isInApplicationStart == 1/*XRAYPREDICATERHS*/)) && ((pid == $target))))/{

this->timedifference = (timestamp - starttime) / 1000; 

printf("<e> -1 0 %d %u %-14d\n%d \n</e>\n",cpu, tid, walltimestamp/1000, this->timedifference);printf("<s>\n");ustack(128);printf("</s>\n");
}

objc$target::-applicationDidFinishLaunching?:entry/((pid == $target))/{

isInApplicationStart = 1; 

printf("<e> -1 1 %d %u %-14d\n%s \n</e>\n",cpu, tid, walltimestamp/1000, probename);printf("<s>\n");ustack(128);printf("</s>\n");
}

objc$target::-applicationDidFinishLaunching?:return/((pid == $target))/{

isInApplicationStart = 0; 

printf("<e> -1 2 %d %u %-14d\n%8.8d \n</e>\n",cpu, tid, walltimestamp/1000, errno);printf("<s>\n");ustack(128);printf("</s>\n");
}

pid$target::main:entry/((pid == $target))/{

starttime = timestamp; 

printf("<e> -1 3 %d %u %-14d\n%s \n</e>\n",cpu, tid, walltimestamp/1000, probefunc);printf("<s>\n");ustack(128);printf("</s>\n");
}


